#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#define N 3  // ƴͼάȣһ3x3ƴͼ

typedef struct Node {
    int puzzle[N][N];  // 洢ƴͼ״̬
    struct Node* parent;  // ָ򸸽ڵָ룬׷·
    int f, g, h;  // A*㷨е f, g, h ֵ
} Node;

// µƴͼڵ
Node* createNode(int puzzle[N][N]) {
    Node* newnode = (Node*)malloc(sizeof(Node));
    //ʵָú
	int i,j;
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			newnode->puzzle[i][j]=puzzle[i][j];
		}
	}
	newnode->parent=NULL;
    newnode->f=0;
    newnode->g=0;
    newnode->h=0;
	return newnode;
}

// ƴͼ״̬Ƿͬ
bool isSamePuzzle(int a[N][N], int b[N][N]) {
    //ͬ򷵻true,򷵻false
	int i,j,k=0;;
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			if(a[i][j]!=b[i][j])
			{
				return false;
				break;
			}
		}
	}
	return true;
}

// ӡƴͼ״̬
void printPuzzle(int puzzle[N][N]) {
    //˫forѭʵƴͼĴӡ
	int i,j;
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			printf("%d ",puzzle[i][j]);
		}
		printf("\n");
	}
    printf("\n");
}


// 㵱ǰ״̬Ŀ״̬Ĺƴ
int heuristic(Node* current, Node* goal) { 
    int h = 0;
    // 㲻ƥƴͼ
	int i,j;
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			if(current->puzzle[i][j]!=goal->puzzle[i][j])
			{
				h++;
			}
		}	
	}	
	return h;
}

// ƶµƴͼ״̬
Node* move(Node* current, int dir) {
    int key_x, key_y;//¼հ׿λ
    // ҵհ׿λ
	int i,j;
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			if(current->puzzle[i][j]==0)
			{
				key_x=i;
				key_y=j;
				break;
			}
		}
	}
    //new_xnew_yֵ
	int new_x=key_x,new_y=key_y;
    // ƶ¿λãƶ
	if(dir==0)
	{
		new_x--;
	}
	else if(dir==1)
	{
		new_x++;
	}
	else if(dir==2)
	{
		new_y--;
	}
	else if(dir==3)
	{
		new_y++;
	}
    // λǷڱ߽
	if(new_x<0||new_x==3||new_y<0||new_y==3)
	{
		return NULL;
	}
    // ½ڵ㣬Ƶǰƴͼ״̬λ
    Node* new_node = createNode(current->puzzle);
    new_node->puzzle[key_x][key_y] = current->puzzle[new_x][new_y];
    new_node->puzzle[new_x][new_y] = 0;
    return new_node;
}

// A*㷨Ѱ·
Node* AStar(Node* start, Node* goal) {
    Node* OPEN[1000];  // бڴ洢̽Ľڵ
    Node* CLOSED[1000];  // رбڴ洢̽Ľڵ
    int OPEN_SIZE = 0;  // бĴС
    int CLOSED_SIZE = 0;  // رбĴС

    OPEN[0] = start;  // ʼڵӵб
    OPEN_SIZE = 1;  // бĴСΪ1
    CLOSED_SIZE = 0;  // رбĴСΪ0

    while (OPEN_SIZE > 0) {//openбв
        int min_f = OPEN[0]->f;//ʼСf
        int min_index = 0;
        // ҿбоСfֵĽڵ
		int i;
		for(i=0;i<OPEN_SIZE;i++)
		{
			if(OPEN[i]->f<min_f)
			{
				min_f=OPEN[i]->f;
				min_index=i;
			}
		}
        Node* current = OPEN[min_index];  // ȡСfֵĽڵ

        // ǰڵĿ״̬ƥ䣬ʾҵ
		if(isSamePuzzle(current->puzzle,goal->puzzle))
		{
			return current;
		}
        //бĴС1ʾӿбƳһڵ
        OPEN_SIZE--;
        //С f ֵĽڵƵбĩβԱԺӵرбС
        //ΪŻбĽṹ
        Node* temp = OPEN[min_index];
        OPEN[min_index] = OPEN[OPEN_SIZE];
        OPEN[OPEN_SIZE] = temp;
        //ǰڵӵرбرбС1
		CLOSED[CLOSED_SIZE]=current;
		CLOSED_SIZE++;
        int key = 0;
        // ҵǰڵпհ׿λ
        int j;
        for (i = 0; i < N; i++) {
            for (j = 0; j < N; j++) {
                if (current->puzzle[i][j] == 0) {
                    key = i * N + j;
                    break;
                }
            }
        }
        // ĸƶ
        int dir;
        for (dir = 0; dir < 4; dir++) {
            Node* new_node = move(current, dir);
            if (new_node != NULL && !isSamePuzzle(new_node->puzzle, current->puzzle)) {
                //õӦgfhֵ
                int gNew = current->g + 1;
                int hNew = heuristic(new_node, goal);
                int fNew = gNew + hNew;

                bool in_OPEN = false;
                int open_index = -1;
                // ½ڵǷڿб
                for (i = 0; i < OPEN_SIZE; i++) {
                    if (isSamePuzzle(new_node->puzzle, OPEN[i]->puzzle)) {
                        in_OPEN = true;
                        open_index = i;
                        break;
                    }
                }

                bool in_CLOSED = false;
                // ½ڵǷڹرб
				for (i = 0; i < CLOSED_SIZE; i++) {
                    if (isSamePuzzle(new_node->puzzle, CLOSED[i]->puzzle)) {
                        in_CLOSED = true;
                        break;
                    }
                }
                //ýڵڿбҲڹرб
                if (!in_OPEN && !in_CLOSED) {
                    //gNewhNewfNewnew_nodӦghfֵ丸ڵΪǰڵ㡣
					new_node->f=fNew;
					new_node->g=gNew;
					new_node->h=hNew;
					new_node->parent=current;
                    // ½ڵnew_nodeббС1
					OPEN[OPEN_SIZE]=new_node;
					OPEN_SIZE++;
                } 
                //½ڵѾڿбУµ f ֵС¿бѴڽڵϢ
                else if (in_OPEN && fNew < OPEN[open_index]->f) 
				{
					OPEN[open_index]=new_node;
                }
            }
        }
    }

    return NULL;  // ޽
}

// ӡ·
void printPath(Node* final) {
    if (final == NULL) {
        return;
    }
    printPath(final->parent);  // ݹӡ·
    int i,j;
    for (i = 0; i < N; i++) {
        if (i%3==0){
            printf("-------\n");
        }
        for ( j = 0; j < N; j++) {
            printf("%d ", final->puzzle[i][j]);
        }
        
        printf("\n");
        
    }
}

int main() {
    //int start[N][N] = {{2, 0, 3}, {1, 8, 4}, {7, 6, 5}};
    //int target[N][N] = {{1, 2, 3}, {8, 0, 4}, {7, 6, 5}};

    //int start[N][N] = {{2, 8, 3}, {1, 6, 4}, {7, 0, 5}};
    //int target[N][N] = {{1, 2, 3}, {8, 0, 4}, {7, 6, 5}};

    int start[N][N] = {{2, 8, 3}, {1, 0, 4}, {7, 6, 5}};
    int target[N][N] = {{1, 0, 3}, {8, 2, 4}, {7, 6, 5}};
    Node* init = createNode(start);
    Node* goal = createNode(target);

    Node* final = AStar(init, goal);
    if (final) {
        printf("This problem has a solution:\n");
        printPath(final);  // ӡ·
    } else {
        printf("This problem has no solution\n");
    }

    return 0;
}
